package com.huimv.farm.damsubsidy.controller;

import cn.hutool.core.date.DateUtil;
import cn.hutool.core.lang.UUID;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.json.JSONUtil;
import cn.hutool.poi.excel.ExcelReader;
import cn.hutool.poi.excel.ExcelUtil;
import com.huimv.farm.damsubsidy.common.annotate.DictTranslate;
import com.huimv.farm.damsubsidy.common.utils.PovertyUtils;
import com.huimv.farm.damsubsidy.common.utils.Result;
import com.huimv.farm.damsubsidy.common.utils.ResultCode;
import com.huimv.farm.damsubsidy.common.utils.UploadImage;
import com.huimv.farm.damsubsidy.entity.PovertyUserRegist;
import com.huimv.farm.damsubsidy.entity.vo.BankResultVo;
import com.huimv.farm.damsubsidy.entity.vo.BankVo;
import com.huimv.farm.damsubsidy.entity.vo.IDCardIfo;
import com.huimv.farm.damsubsidy.entity.vo.IDCardVo;
import okhttp3.*;
import okhttp3.RequestBody;
import okhttp3.ResponseBody;
import org.apache.commons.collections.CollectionUtils;
import org.json.JSONException;
import org.json.JSONObject;
import org.springframework.util.StringUtils;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import sun.misc.BASE64Encoder;

import javax.imageio.ImageIO;
import java.io.*;
import java.lang.reflect.Field;
import java.net.URLEncoder;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.*;
import java.util.stream.Collectors;

@CrossOrigin
@RestController
@RequestMapping("/image")
public class ImagesTest {


    @PostMapping("/test")
    public  String test( @RequestParam("image") MultipartFile image
            ) throws IOException {
        return   UploadImage.getImageCom(image);
//        System.out.println(image);
//        String imgname = "成功";
//        String originalFilename = image.getOriginalFilename();
//        String filenameExtension = StringUtils.getFilenameExtension(originalFilename);
//        String path = DateUtil.format(new Date(), "yyyy-MM");
//        try {
//            InputStream inputStream = image.getInputStream();
//            BufferedInputStream in = new BufferedInputStream(inputStream);
//            ByteArrayOutputStream out = new ByteArrayOutputStream(1024);
//
//            byte[] temp = new byte[1024];
//            int size = 0;
//            while ((size = in.read(temp)) != -1) {
//                out.write(temp, 0, size);
//            }
//            in.close();
//            byte[] content = out.toByteArray();
            //获取压缩后的图片
//            byte[] imageCom = UploadImage.getImageCom(image);

//            imgname = UUID.randomUUID() + "." + filenameExtension;
//            byte[] bytes = UploadImage.resizeImage(content, 0.5F);
//            UploadImage.sshSftp(imageCom, path, imgname);
//        } catch (Exception e) {
//            e.printStackTrace();
//        }
//        String content = "https://dam.img.ifarmcloud.com:8030/images" + path + "/" + imgname;
//        String content = "https://dam.img.ifarmcloud.com:8030/images/" + path + "/" + imgname;

//        return content;
    }


   /* @RequestMapping("excelTest/import")
    @ResponseBody
     public String evaluationUpdate(@RequestParam(value = "file", required = true) MultipartFile file,) throws Exception {
        ExcelReader reader = ExcelUtil.getReader(file.getInputStream());
        List<Map<String, Object>> read = reader.read(2, 3, 2147483647);
        List<PovertyUserRegist> poverty = PovertyUtils.getPoverty(read);
        return "成功";
    }*/

  /*  public static void main(String []args) throws IOException, JSONException {
        MediaType mediaType = MediaType.parse("application/x-www-form-urlencoded");
        // image 可以通过 getFileContentAsBase64("C:\fakepath\039fc6cbebda8c7d48ed16b4bbf03d7.jpg") 方法获取,如果Content-Type是application/x-www-form-urlencoded时,第二个参数传true
        Request request = new Request.Builder()
                .url("https://aip.baidubce.com/rest/2.0/ocr/v1/idcard?access_token=" + getAccessToken())
                .method("POST", body)
                .addHeader("Content-Type", "application/x-www-form-urlencoded")
                .addHeader("Accept", "application/json")
                .build();
        Response response = HTTP_CLIENT.newCall(request).execute();
        System.out.println(response.body().string());

    }*/



   public static final String API_KEY = "tOWx25FyomcHf51HDQqQUhSq";
    public static final String SECRET_KEY = "6MOI0wIGqstuFk3xO6D0nHYaKdvn6DPD";
    static final OkHttpClient HTTP_CLIENT = new OkHttpClient().newBuilder().build();


    @RequestMapping("/excelTest/import")
     public Result evaluationUpdate(@RequestParam("image") MultipartFile file) throws Exception {

        if (ObjectUtil.isEmpty(file)){
            return  new Result(10001,"图片识别失败",false);
        }
        BASE64Encoder encoder = new BASE64Encoder();
        String  fileStr = encoder.encode(file.getBytes());
        String image = URLEncoder.encode(fileStr, "utf-8");
           MediaType mediaType = MediaType.parse("application/x-www-form-urlencoded");
           // image 可以通过 getFileContentAsBase64("C:\fakepath\039fc6cbebda8c7d48ed16b4bbf03d7.jpg") 方法获取,如果Content-Type是application/x-www-form-urlencoded时,第二个参数传true
      okhttp3.RequestBody body = okhttp3.RequestBody.create(mediaType, "id_card_side=front&image="+image+"&detect_risk=true&detect_quality=true&detect_photo=true&detect_card=true&detect_direction=true");

        Request request = new Request.Builder()
                   .url("https://aip.baidubce.com/rest/2.0/ocr/v1/idcard?access_token=" + getAccessToken())
                   .method("POST", body)
                   .addHeader("Content-Type", "application/x-www-form-urlencoded")
                   .addHeader("Accept", "application/json")
                   .build();
           Response response = HTTP_CLIENT.newCall(request).execute();
        String body1 = response.body().string();
        IDCardVo idCardVo = JSONUtil.toBean(body1, IDCardVo.class);
        Integer idcardNumberType = idCardVo.getIdcardNumberType();
        if (idcardNumberType != 1){
            String reslut = "";
            switch (idcardNumberType){
                case -1:
                    reslut = "身份证正面所有字段全为空";
                    break;
                case 0:
                    reslut = "身份证证号不合法，此情况下不返回身份证证号";
                    break;
                case 2:
                    reslut = "身份证证号和性别、出生信息都不一致";
                    break;
                case 3:
                    reslut = "身份证证号和出生信息不一致";
                    break;
                default:
                    reslut = "身份证证号和性别信息不一致";

            }
            return  new Result(10001,reslut,false);
        }
        Map map  = new HashMap();
        System.out.println(idCardVo.getIdcardNumberType());
        Map<String, IDCardIfo> wordsResult = idCardVo.getWordsResult();
        System.out.println(wordsResult.toString());
        if (ObjectUtil.isNotEmpty(wordsResult.get("住址"))){
            map.put("addr" ,wordsResult.get("住址").getWords());
        }
        if (ObjectUtil.isNotEmpty(wordsResult.get("公民身份号码"))){
            map.put("IDCARD" ,wordsResult.get("公民身份号码").getWords());
        }
        if (ObjectUtil.isNotEmpty(wordsResult.get("出生"))){
            map.put("birthday" , wordsResult.get("出生").getWords());
        }
        if (ObjectUtil.isNotEmpty(wordsResult.get("姓名"))){
            map.put("name" , wordsResult.get("姓名").getWords());
        }
        if (ObjectUtil.isNotEmpty(wordsResult.get("性别"))){
            map.put("sex" , wordsResult.get("性别").getWords());
        }
        if (ObjectUtil.isNotEmpty(wordsResult.get("民族"))){
            map.put("nation" , wordsResult.get("民族").getWords());
        }
        if (ObjectUtil.isNotEmpty(wordsResult.get("失效日期"))){
            map.put("shiXiao" ,  wordsResult.get("失效日期").getWords());
        }
        if (ObjectUtil.isNotEmpty(wordsResult.get("签发机关"))){
            map.put("qfjg" , wordsResult.get("签发机关").getWords());
        }
        if (ObjectUtil.isNotEmpty(wordsResult.get("签发日期"))){
            map.put("qfrq" , wordsResult.get("签发日期").getWords());
        }

//        return "识别成功";
        return  new Result(ResultCode.SUCCESS,map);
    }


    @RequestMapping("/bankcard")
    public Result bankcard(@RequestParam("image") MultipartFile file) throws Exception {

        if (ObjectUtil.isEmpty(file)){
            return  new Result(10001,"图片识别失败",false);
        }
        BASE64Encoder encoder = new BASE64Encoder();
        String  fileStr = encoder.encode(file.getBytes());
        String image = URLEncoder.encode(fileStr, "utf-8");
        MediaType mediaType = MediaType.parse("application/x-www-form-urlencoded");
        // image 可以通过 getFileContentAsBase64("C:\fakepath\039fc6cbebda8c7d48ed16b4bbf03d7.jpg") 方法获取,如果Content-Type是application/x-www-form-urlencoded时,第二个参数传true
        okhttp3.RequestBody body = okhttp3.RequestBody.create(mediaType, "image="+image);

        Request request = new Request.Builder()
                .url("https://aip.baidubce.com/rest/2.0/ocr/v1/bankcard?access_token=" + getAccessToken())
                .method("POST", body)
                .addHeader("Content-Type", "application/x-www-form-urlencoded")
                .addHeader("Accept", "application/json")
                .build();
        Response response = HTTP_CLIENT.newCall(request).execute();
        String body1 = response.body().string();
        BankVo bankVo = JSONUtil.toBean(body1, BankVo.class);
        if (ObjectUtil.isEmpty(bankVo)){
            return new Result(10001,"识别失败",false);
        }
        BankResultVo result = bankVo.getResult();

        if (ObjectUtil.isEmpty(result)){
            return new Result(10001,"识别失败",false);
        }
//        return "识别成功";
        return  new Result(ResultCode.SUCCESS,result);
    }



    /**
     * 获取文件base64编码
     *
     * @param path      文件路径
     * @param urlEncode 如果Content-Type是application/x-www-form-urlencoded时,传true
     * @return base64编码信息，不带文件头
     * @throws IOException IO异常
     */
    static String getFileContentAsBase64(String path, boolean urlEncode) throws IOException {
        byte[] b = Files.readAllBytes(Paths.get(path));
        String base64 = Base64.getEncoder().encodeToString(b);
        if (urlEncode) {
            base64 = URLEncoder.encode(base64, "utf-8");
        }
        return base64;
    }


    /**
     * 从用户的AK，SK生成鉴权签名（Access Token）
     *
     * @return 鉴权签名（Access Token）
     * @throws IOException IO异常
     */
    static String getAccessToken() throws IOException, JSONException {
        MediaType mediaType = MediaType.parse("application/x-www-form-urlencoded");
        okhttp3.RequestBody body = RequestBody.create(mediaType, "grant_type=client_credentials&client_id=" + API_KEY
                + "&client_secret=" + SECRET_KEY);
        Request request = new Request.Builder()
                .url("https://aip.baidubce.com/oauth/2.0/token")
                .method("POST", body)
                .addHeader("Content-Type", "application/x-www-form-urlencoded")
                .build();
        Response response = HTTP_CLIENT.newCall(request).execute();
        return new JSONObject(response.body().string()).getString("access_token");
    }

}
